'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSelect = require('react-select');

var _common = require('./common');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  value: _propTypes2.default.array,
  filterText: _propTypes2.default.string,
  onChange: _propTypes2.default.func.isRequired,
  onTextChange: _propTypes2.default.func.isRequired,
  options: _propTypes2.default.array.isRequired,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  hasFilterable: _propTypes2.default.bool,
  placeholder: _propTypes2.default.node,
  style: _propTypes2.default.object
};

var Filter = function (_Component) {
  _inherits(Filter, _Component);

  function Filter(props) {
    _classCallCheck(this, Filter);

    var _this = _possibleConstructorReturn(this, (Filter.__proto__ || Object.getPrototypeOf(Filter)).call(this, props));

    _this.handleInputChange = _this.handleInputChange.bind(_this);
    _this.handleCreateOption = _this.handleCreateOption.bind(_this);
    _this.handleBlur = _this.handleBlur.bind(_this);
    return _this;
  }

  _createClass(Filter, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      var _props = this.props,
          value = _props.value,
          filterText = _props.filterText,
          options = _props.options;

      if (nextProps.value !== value || nextProps.options !== options || nextProps.filterText !== filterText) {
        return true;
      }
      return false;
    }
  }, {
    key: 'handleInputChange',
    value: function handleInputChange(text, _ref) {
      var action = _ref.action;
      var onTextChange = this.props.onTextChange;
      // prevent blur from clearing text that wasn't confirmed with tab or enter

      if (action !== 'input-blur' && action !== 'menu-close') {
        onTextChange(text);
      }
    }
  }, {
    key: 'handleBlur',
    value: function handleBlur(e) {
      // preserve text on blur
      var onTextChange = this.props.onTextChange;

      var val = e.target.value;
      if (val !== '') {
        onTextChange(val);
      }
    }
  }, {
    key: 'handleCreateOption',
    value: function handleCreateOption(val) {
      var _props2 = this.props,
          onChange = _props2.onChange,
          value = _props2.value;

      var opt = (0, _common.createTextFilter)(val);
      onChange([].concat(_toConsumableArray(value), [opt]), 'create-option');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          value = _props3.value,
          filterText = _props3.filterText,
          _onChange = _props3.onChange,
          options = _props3.options,
          className = _props3.className,
          classNamePrefix = _props3.classNamePrefix,
          hasFilterable = _props3.hasFilterable,
          placeholder = _props3.placeholder,
          style = _props3.style;

      var defaultPlaceholder = hasFilterable ? 'Search or filter using tags...' : 'Search...';
      return _react2.default.createElement(_reactSelect.Creatable, {
        classNamePrefix: classNamePrefix || 'Select',
        className: className,
        options: options,
        noOptionsMessage: function noOptionsMessage() {
          return 'Type text to search, press Enter to save as filter';
        },
        placeholder: placeholder || defaultPlaceholder,
        formatCreateLabel: function formatCreateLabel(txt) {
          return 'Create \'' + txt + '\' filter';
        },
        createOptionPosition: 'first',
        isValidNewOption: function isValidNewOption(input) {
          return !!input;
        },
        onChange: function onChange(selected, meta) {
          return _onChange(selected, meta.action);
        },
        onInputChange: this.handleInputChange,
        onCreateOption: this.handleCreateOption,
        onBlur: this.handleBlur,
        value: value,
        inputValue: filterText || '',
        isMulti: true,
        style: style
      });
    }
  }]);

  return Filter;
}(_react.Component);

Filter.propTypes = propTypes;
exports.default = Filter;