'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _selectors = require('./selectors');

var _selectors2 = _interopRequireDefault(_selectors);

var _actions = require('./actions');

var _Pagination = require('./Pagination');

var _Pagination2 = _interopRequireDefault(_Pagination);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var mapStateToProps = function mapStateToProps(state, props) {
  var tableName = props.tableName;

  var selectors = (0, _selectors2.default)(tableName);
  var isInitialized = selectors.getIsInitialized(state);

  if (!isInitialized) {
    return {
      isInitialized: isInitialized
    };
  }

  var pageInfo = selectors.getPageInfo(state, props);

  return _extends({
    isInitialized: isInitialized
  }, pageInfo);
};

var mapDispatchToProps = function mapDispatchToProps(dispatch, _ref) {
  var tableName = _ref.tableName;
  return {
    onPageChange: function onPageChange(page) {
      return dispatch((0, _actions.tablePageChanged)(tableName, page));
    }
  };
};

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(function (_ref2) {
  var isInitialized = _ref2.isInitialized,
      otherProps = _objectWithoutProperties(_ref2, ['isInitialized']);

  if (!isInitialized) {
    return null;
  }
  return _react2.default.createElement(_Pagination2.default, otherProps);
});